void setup(){
  
  // screen

  size(1400,768);
  background(255);
  frameRate(60);
  smooth();
  

  // font

  gFont = createFont("Helvetica", 34);
  gFont2 = createFont("Helvetica", 22);
  gFont3 = createFont("Helvetica", 12);
  gFont4 = createFont("Helvetica-bold", 16);
  

  // fetch result

  pResult_Div10a_Apple     = new int[10];
  pResult_Div10b_Apple     = new int[10];
  pResult_Div10a_Microsoft = new int[10];
  pResult_Div10b_Microsoft = new int[10];
  pResult_Div100a_Apple     = new int[100];
  pResult_Div100b_Apple     = new int[100];
  pResult_Div100a_Microsoft = new int[100];
  pResult_Div100b_Microsoft = new int[100];
  

  // connecting to the KRAKEN database

  println("connecting to database ...");

  msql = new MySQL( this, MySQL_host, MySQL_database, MySQL_user, MySQL_pass ); //host, database, user, password
  assert( msql!=null && msql.connect() );


  // fetching results (10)

  println("querying: count result by 'apple' keyword");

  msql.query( getSearchQuery("apple", 100) );  
  while( msql.next() ) {
    pResult_Div10a_Apple[msql.getInt(1)] = msql.getInt(2);
  }
  
  println("querying: count result by 'apple' keyword between 2001 and 2011");

  msql.query( getSearchBetweenYearsQuery("apple", 2001, 2011, 100) ); 
  while( msql.next() ) {
    pResult_Div10b_Apple[msql.getInt(1)] = msql.getInt(2);
  }

  println("querying: count result by 'microsoft' keyword");

  msql.query( getSearchQuery("microsoft", 100) );
  while( msql.next() )  {
    pResult_Div10a_Microsoft[msql.getInt(1)] = msql.getInt(2);
  }
  
  println("querying: count result by 'microsoft' keyword between 2001 and 2011");

  msql.query( getSearchBetweenYearsQuery("microsoft", 2001, 2011, 100) );
  while( msql.next() ) {
    pResult_Div10b_Microsoft[msql.getInt(1)] = msql.getInt(2);
  }


  // fetching results (100)

  println("querying: count result by 'apple' keyword");

  msql.query( getSearchQuery("apple", 10) );  
  while( msql.next() ) {
    pResult_Div100a_Apple[msql.getInt(1)] = msql.getInt(2);
  }
  
  println("querying: count result by 'apple' keyword between 2001 and 2011");

  msql.query( getSearchBetweenYearsQuery("apple", 2001, 2011, 10) );  
  while( msql.next() ) {
    pResult_Div100b_Apple[msql.getInt(1)] = msql.getInt(2);
  }

  println("querying: count result by 'microsoft' keyword");

  msql.query( getSearchQuery("microsoft", 10) );
  while( msql.next() )  {
    pResult_Div100a_Microsoft[msql.getInt(1)] = msql.getInt(2);
  }
  
  println("querying: count result by 'microsoft' keyword between 2001 and 2011");

  msql.query( getSearchBetweenYearsQuery("microsoft", 2001, 2011, 10) );
  while( msql.next() ) {
    pResult_Div100b_Microsoft[msql.getInt(1)] = msql.getInt(2);
  }
  
  
  // mode change
  fAnimateMode1Ratio1 = .0f;
  fAnimateMode1Ratio2 = .0f;
  nTimeStart = millis();
  displayMode = 1;
  
  
  // end
}

